/*
 * $Id$
 */

package org.codehaus.mojo.nbm.model;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * 
 * 
 * @version $Revision$ $Date$
 */
public class Dependency implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field id
     */
    private String id;

    /**
     * Field type
     */
    private String type = "spec";

    /**
     * Field explicitValue
     */
    private String explicitValue;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Get 
     *                         The plugin tries to resolve the
     * correct module name and module specification/implementation
     * version by examining the
     *                         dependency jar's manifest.
     *                         You can override this behaviour by
     * explicitly defining the value here. For example
     * org.openide.io/1 &gt; 10.1 for a "spec" type of dependency.
     *           
     *                                       
     *                     
     */
    public String getExplicitValue()
    {
        return this.explicitValue;
    } //-- String getExplicitValue() 

    /**
     * Get groupId:artifactId of the dependency defined in the POM
     * (or a transitive dependency)
     */
    public String getId()
    {
        return this.id;
    } //-- String getId() 

    /**
     * Get 
     *                         Type of module dependency. 3
     * possible values allowed.
     *                         <p><b>spec</b> - specification
     * dependency, module can only use public APIs in public
     * packages. Works with the version defined and any later
     * version.</p>
     *                         <p><b>impl</b> - implementation
     * dependency, module can use any class in the dependency
     * module, but works with just the one version of the
     * module.</p>
     *                         <p><b>loose</b> - similar to spec,
     * but isa very loose connection, no version is required, just
     * the module presence.</p>
     *                         
     *                     
     */
    public String getType()
    {
        return this.type;
    } //-- String getType() 

    /**
     * Set 
     *                         The plugin tries to resolve the
     * correct module name and module specification/implementation
     * version by examining the
     *                         dependency jar's manifest.
     *                         You can override this behaviour by
     * explicitly defining the value here. For example
     * org.openide.io/1 &gt; 10.1 for a "spec" type of dependency.
     *           
     *                                       
     *                     
     * 
     * @param explicitValue
     */
    public void setExplicitValue(String explicitValue)
    {
        this.explicitValue = explicitValue;
    } //-- void setExplicitValue(String) 

    /**
     * Set groupId:artifactId of the dependency defined in the POM
     * (or a transitive dependency)
     * 
     * @param id
     */
    public void setId(String id)
    {
        this.id = id;
    } //-- void setId(String) 

    /**
     * Set 
     *                         Type of module dependency. 3
     * possible values allowed.
     *                         <p><b>spec</b> - specification
     * dependency, module can only use public APIs in public
     * packages. Works with the version defined and any later
     * version.</p>
     *                         <p><b>impl</b> - implementation
     * dependency, module can use any class in the dependency
     * module, but works with just the one version of the
     * module.</p>
     *                         <p><b>loose</b> - similar to spec,
     * but isa very loose connection, no version is required, just
     * the module presence.</p>
     *                         
     *                     
     * 
     * @param type
     */
    public void setType(String type)
    {
        this.type = type;
    } //-- void setType(String) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }}
